
public class BetterArray<E> {

	private final int DEFAULT_ARRAY_SIZE = 100;

	private int count;
	private E[] array;

	public BetterArray() {
		this.count = 0;
		this.array = (E[]) new Object[DEFAULT_ARRAY_SIZE];
	}

	public BetterArray(int size) {
		this.count = 0;
		if (size > 0) {
			this.array = (E[]) new Object[size];
		} else {
			this.array = (E[]) new Object[DEFAULT_ARRAY_SIZE];
		}
	}
	
	public int size() {
		return this.count;
	}
	
	public boolean isEmpty() {
		return (this.count == 0);
	}
	
	public void add(E element) {
	 	if (this.count == this.array.length) {
			increaseArraySize();
		}
		this.array[this.count++] = element;
	}
	
	public void add(E element, int index) {
		if ((index < 0) || (index > this.count)) {
			return;
		} else if (this.count == this.array.length) {
			increaseArraySize();
		} 
		
		if (index == this.count) {
			this.add(element);
		} else {
			for ( int i = this.count ; i > index ; i-- ) {
				this.array[i] = this.array[i-1];
			}
			this.array[index] = element;
			this.count++;
		}
	}

	
	public E get(int index) {
		if ((index >= 0) && (index < this.count)) {
			return this.array[index];
		} else {
			return null;
		}
	}
	
	public E replace(E element, int index) {
		if ((index >= 0) && (index < this.count)) {
			E oldElement = this.array[index];
			this.array[index] = element;
			return oldElement;
		} else {
			return null;
		}		
	}
	
	public E remove(int index) {
		if ((index < 0) || (index > (this.count - 1))) {
			return null;
		} else {
			E element = this.array[index];
			for ( int i = index ; i < (this.count - 1) ; i++ ) {
				this.array[i] = this.array[i+1];
			}
			this.count--;
			return element;
		}
	}
	
	
	public void removeAll() {
		for ( int i = 0 ; i < this.array.length ; i++ ) {
			this.array[i] = null;
		}
		this.count = 0;
	}
	
	
	private void increaseArraySize() {
		E[] newArray = (E[]) new Object[this.array.length + this.DEFAULT_ARRAY_SIZE];
		for ( int i = 0 ; i < this.array.length ; i++ ) {
			newArray[i] = this.array[i];
		}
		this.array = newArray;
	}

	@Override
	public String toString() {
		String s = "array = {";
		for ( int i = 0 ; i < this.count ; i++ ) {
			if ( i < this.count - 1) {
				s = s + this.array[i] + ", ";
			} else {
				s = s + this.array[i] + "}";
			}
		}
		return s;
	}

	
}
